#CS --------------------------------------
Autoit script to convert *.SoundNodeWave to .txt
Games supported: Afterfall Insanity (will likely not work with other games).
Original code by: swuforce 
Modified by: MajKSA
#CE --------------------------------------
#include <WinAPI.au3>
#Include <File.au3>
#include <ArrayNaturalSort.au3>

$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no SoundNodeWave files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text

For $i=1 to $Names[0]
		$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
		FileSetPos($File,28, $FILE_BEGIN)	 ;always 28 byte
		$Length = Int(FileRead($File,4))     ;length of ID
		FileRead($File,$Length)			     ;ID
		FileRead($File, 164)			     ;always 164 byte
		$Length = Int(FileRead($File,4))     ;length of subtitle
		If $Length < 0 Then                                   ;if length is negative this means unicode
			$Length = -$Length*2
			$Str = BinaryToString(FileRead($File,$Length),2)  ;subtitle (unicode)
			$Str = StringTrimRight($Str,1)
		Else
			$Str = BinaryToString(FileRead($File,$Length))    ;subtitle
			$Str = StringTrimRight($Str,1)
		EndIf
		
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		FileClose($File)
Next

$hAllTextFil = FileOpen (CompGetFileName($Dir)&".txt", 2)
FileWrite ($hAllTextFil, $Text)
FileClose ($hAllTextFil)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)

Func CompGetFileName($Path)
	If StringLen($Path) < 4 Then Return -1
	$ret = StringSplit($Path,"\",2)
	If IsArray($ret) Then
	Return $ret[UBound($ret)-1]
	EndIf
	If @error Then Return -1
EndFunc