#CS --------------------------------------
Autoit script to import subtitles from txt to *.SoundNodeWave
Games supported: Afterfall Insanity (will likely not work with other games).
by: MajKSA
#CE --------------------------------------
#include <WinAPI.au3>
#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>  


;-------------------------------------------------------------------------------
;استخراج الترجمة من ملف النص
Dim $TranslatedLines
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$TranslatedLines)

;استخراج الملفات المدعومة من المجلد الذي يحدده المستخدم
$Dir = FileSelectFolder ("Select the folder اختر مجلد...", "", "", @ScriptDir)
If $Dir = "" Then Exit
$FileType = "SoundNodeWave"
$Files = _FileListToArrayRec($Dir, "*."&$FileType, 1,1)
If $Files = "" Then Exit MsgBox(0,"لا بوجد ملفات مدعومة","There are no "&$FileType&" files in the "&@cr&$Dir)

if $TranslatedLines[0] <> $Files[0] then
		MsgBox(0, "", "عدد الأسطر في ملف النص لا يساوي عدد الملفات المراد تعديلها" &@CR _
		&"File count and txt lines count not matched")
		Exit
EndIF
	
$Edited = 0      ;عداد للملفات التي تم تعديلها
$Same = 0        ;عداد للملفات التي ترجمتها هي نفس الأصل

;-------------------------------------------------------------------------------
;بدء التعامل مع الملفات واحد تلو الآخر
For $i = 1 To $Files[0] Step +1
	; Binary قراءة الملف في وضع
	$Path = $Dir &"\"& $Files[$i]                 ;مسار الملف الحالي
	$File = FileOpen ($Path, BitOR(16, 1))        ;binary mode
	
	;وضع الملف في متغير لاستخراج معلومات منه عبر دالة خارجية
	FileSetPos($File, 0, $FILE_BEGIN)
	$BinaryFile = FileRead($File) 
	
	; تجاوز بيانات لا نحتاجها من البداية إلى ما قبل الجملة
	FileSetPos($File,28, $FILE_BEGIN)               ;always 28 byte
	$tempLen = Int(FileRead($File, 4))              ;Length of ID 
	if $tempLen < 0 then $tempLen = $tempLen *-1 *2 ;UNICODE إذا كان الطول بالسالب فهذا يعني أنه
	FileRead($File, $tempLen)                       ;ID
	FileRead($File, 164)			                ;always 164 byte

	;استخراج الجملة وطولها
	$LengthPos = FileGetPos($File)                ;حفظ مكان ما قبل طول الجملة
	$Length = Int(FileRead($File,4))              ;قراءة طول الجملة الإنجليزية
	$isUnicode = False
	if $Length < 0 then                           ;UNICODE إذا كان الطول بالسالب فهذا يعني أنه
		$isUnicode = True
		$Length = $Length * -1                    ; إزالة السالب
		$Length = $Length * 2                     ; لأن الحرف الواحد في اليونيكود يأخذ 2 بايت
		$Length = $Length - 2                     ;00 00 null لأن آخر 2 بايت هما
	Else 
		$Length = $Length - 1                     ;00 null ناقص واحد لآن آخر بايت فيها فارغ
	EndIf
	; $pos = FileGetPos($File)                    ;حفظ مكان بداية الجملة
	$SentenseBin = FileRead($File,$Length)        ;Binary الجملة كـ
	if $isUnicode then                            ;الجملة كنص عادي
		$SentenseStr = BinaryToString($SentenseBin, $SB_UTF16LE) ;UNICODE
	Else
		$SentenseStr = BinaryToString($SentenseBin, $SB_UTF8) ;ASCII
	EndIf
	; MsgBox(0, '', 'Length=' & $Length & @CR &  StringReplace($SentenseStr, Chr(0), ""))

	;حفظ ما قبل الجملة و ما بعد الجملة
	FileSetPos($File, 0, $FILE_BEGIN)
	$FromStartToBefore = FileRead($File, $LengthPos)     ;من بداية الملف  إلى قبل طول الجملة
	FileRead($File, 4 + $Length)                         ;تخطي الجملة وطولها
	FileRead($File, 1)                                   ;تخطي البايت الفارغ بعد الجملة - سيضاف لاحقا
	if $isUnicode then FileRead($File, 1)                ;تخطي البايت الإضافي في اليونيكود
	$AfterToEnd = FileRead($File)                        ;من بعد الجملة إلى نهاية الملف
	FileClose ($File)

	; MsgBox(0, BinaryLen($FromStartToBefore), $FromStartToBefore)
	; MsgBox(0, BinaryLen($AfterToEnd), $AfterToEnd)
	;------------------------------------------------------
	; تجهيز الترجمة الجديدة    
	$TranslationStr = $TranslatedLines[$i]
	$TranslationStr = StringReplace($TranslationStr,"\n",@CR)  ;علامة نهاية السطر
	if $SentenseStr = $TranslationStr then               ;تخطي الملف إذا كانت الترجمة نفس الأصل
		$Same = $Same + 1
		ContinueLoop
	EndIF
	If $TranslationStr = "" then ContinueLoop             ;تخطي الملف إذا كانت الترجمة فارغة 
	;الترجمة وطولها
	$TranslationStr = $TranslationStr & Chr(0)             ;إضافة البايت الفارغ الذي تم تجاوزه سابقا
	$TranslationBin = StringToBinary($TranslationStr, $SB_UTF16LE)      ;Binary الترجمة كـ
	$NewLength = StringLen($TranslationStr)                ;طول الترجمة
	$NewLength = - $NewLength                              ; لأن طول الجملة باليونيكود يتم تخزينه بالسالب
	$NewLengthBin = Binary($NewLength)                     ;Binary الطول كـ                         

	; إعادة تجميع أجزاء الملف وحفظه
	$NewContent = $FromStartToBefore & $NewLengthBin & $TranslationBin & $AfterToEnd

	;إعادة فتح الملف بأسلوب آخر يسمح لنا بمسح المحتوى القديم واستبداله بالجديد
	$File = FileOpen ($Path, 16+2)  ;$FO_BINARY (16) +  $FO_OVERWRITE (2)
	If Not FileWrite($File, $NewContent) Then MsgBox($MB_SYSTEMMODAL, "", "خطأ في الكتابة إلى الملف") 
	FileClose ($File)
	$Edited = $Edited + 1 
Next

TrayTip("Finish", " Done ! By: MajKSA", 3)
		
; TrayTip("Finish", " Done ! Edited "& $Edited &" of "& $Files[0] &" files (same subtitle found = "&$Same&")"& _
		; @cr&"تم تعديل "& $Edited &" من "& $Files[0] &" ملف "& _
		; @cr&"عدد الترجمات التي كانت نفس الموجودة = "& $Same &@cr& _
		; @cr&"By: MajKSA", 3)